/*---------------------------------------------------------------------------
* 							Dr. Fritz Faulhaber GmbH & Co.KG
*----------------------------------------------------------------------------
*//**\file
* \brief    Definition of class TFormMain
* 	Provides the interaction with the demo user interface,
* 	uses CMomanLibSample to get access to the FAULHABER communiction API.
*/
//---------------------------------------------------------------------------

#ifndef MainVCLH
#define MainVCLH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
//---------------------------------------------------------------------------

#include "MomanLibSample.h"
//---------------------------------------------------------------------------

#define WM_COMDATA	(WM_USER+1)
//---------------------------------------------------------------------------

class TFormMain : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
	TStatusBar *StatusBar1;
	TButton *ButtonGetStrObj;
	TRichEdit *RichEdit1;
	TLabel *Label1;
	TButton *ButtonShutdown;
	TButton *ButtonSwitchOn;
	TButton *ButtonEnOp;
	TLabel *Label2;
	TLabel *Label3;
	TButton *ButtonRelPos;
	TLabel *Label4;
	void __fastcall ButtonGetStrObjClick(TObject *Sender);
	void __fastcall ButtonShutdownClick(TObject *Sender);
	void __fastcall ButtonSwitchOnClick(TObject *Sender);
	void __fastcall ButtonEnOpClick(TObject *Sender);
	void __fastcall ButtonRelPosClick(TObject *Sender);

private:	// Benutzer-Deklarationen
	CMomanLibSample* MomanLibSample;
	bool m_bMomanLibLoaded;

	//Event-Handling:
	void __fastcall WMComData(TMessage& Msg);
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_COMDATA, TMessage, WMComData)
	END_MESSAGE_MAP(TForm)

public:		// Benutzer-Deklarationen
	__fastcall TFormMain(TComponent* Owner);
	__fastcall ~TFormMain();

};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
