/*---------------------------------------------------------------------------
* 							Dr. Fritz Faulhaber GmbH & Co.KG
*----------------------------------------------------------------------------
*//**\file
* \brief   Definition of class CMomanLibSample as wrapper for
*				MomanLib API functions used in the C++ demo examples
*/
//---------------------------------------------------------------------------

#ifndef MomanLibSampleH
#define MomanLibSampleH
//---------------------------------------------------------------------------
#include <string>
#include <windows.h>

#include "Momancmd.h"
#include "Momanprot.h"
//---------------------------------------------------------------------------


class CMomanLibSample
{
private:
	tdmmProtInitInterface mmProtInitInterface;
	tdmmProtCloseInterface mmProtCloseInterface;
	tdmmProtOpenCom mmProtOpenCom;
	tdmmProtCloseCom mmProtCloseCom;
	tdmmProtSendCommand mmProtSendCommand;
	tdmmProtReadAnswer mmProtReadAnswer;
	tdmmProtDecodeAnswStr mmProtDecodeAnswStr;
	tdmmProtGetStrObj mmProtGetStrObj;
	tdmmProtSetObj mmProtSetObj;
	tdmmProtGetAbortMessage mmProtGetAbortMessage;

	HINSTANCE m_hProtocolDll;
	bool m_isComOpen;
	int m_Statusword;
	std::string m_abortMessage;

public:
	CMomanLibSample();
	~CMomanLibSample();

	bool Init(tdmmProtDataCallback SignalDataReceived);
	bool GetStrObj(int nodeNr, int index, int subIndex, std::string& value);
	bool SendCommand(int nodeNr, eMomancmd cmd);
	bool ReadReceivedData(std::string& data, std::string& cmd);
	bool SetObj(int nodeNr, int index, int subIndex, int value, int len);
	int GetStatusword(void);
	std::string GetAbortMessage(void);

};
//---------------------------------------------------------------------------
#endif
